//this source code was auto-generated by tolua#, do not modify it
using System;
using LuaInterface;

public class CLASSTAG_MD5HashingWrap
{
    public static void Register(LuaState L)
    {
        L.BeginStaticLibs("MD5Hashing");
        L.RegFunction("HashString", FUNCTAG_HashString);
        L.RegFunction("HashUsernameString", FUNCTAG_HashUsernameString);
        L.RegFunction("HashFile", FUNCTAG_HashFile);
        L.RegFunction("HashBytes", FUNCTAG_HashBytes);
        L.EndStaticLibs();
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_HashString(IntPtr L)
    {
        try
        {
            int count = LuaDLL.lua_gettop(L);

            if (count == 1 && TypeChecker.CheckTypes(L, 1, typeof(string)))
            {
                string arg0 = ToLua.ToString(L, 1);
                string o = CLASSTAG_MD5Hashing.HashString(arg0);
                LuaDLL.lua_pushstring(L, o);
                return 1;
            }
            else if (count == 2 && TypeChecker.CheckTypes(L, 1, typeof(System.Text.Encoding), typeof(string)))
            {
                System.Text.Encoding arg0 = (System.Text.Encoding)ToLua.ToObject(L, 1);
                string arg1 = ToLua.ToString(L, 2);
                string o = CLASSTAG_MD5Hashing.HashString(arg0, arg1);
                LuaDLL.lua_pushstring(L, o);
                return 1;
            }
            else
            {
                return LuaDLL.luaL_throw(L, "invalid arguments to method: CLASSTAG_MD5Hashing.HashString");
            }
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_HashUsernameString(IntPtr L)
    {
        try
        {
            //int count = LuaDLL.lua_gettop(L);

            //if (count == 1 && TypeChecker.CheckTypes(L, 1, typeof(string)))
            //{
            //    string arg0 = ToLua.ToString(L, 1);
            //    string o = CLASSTAG_MD5Hashing.HashString(arg0);
            //    LuaDLL.lua_pushstring(L, o);
            //    return 1;
            //}
            //else if (count == 2 && TypeChecker.CheckTypes(L, 1, typeof(System.Text.Encoding), typeof(string)))
            //{
            //    System.Text.Encoding arg0 = (System.Text.Encoding)ToLua.ToObject(L, 1);
            //    string arg1 = ToLua.ToString(L, 2);
            //    string o = CLASSTAG_MD5Hashing.HashString(arg0, arg1);
            //    LuaDLL.lua_pushstring(L, o);
            //    return 1;
            //}
            int count = LuaDLL.lua_gettop(L);
            if (count == 2)
            {
                string arg0 = ToLua.ToString(L, 1);
                string arg1 = ToLua.ToString(L, 2);

                string keymd5 = "";

                if (GameLauncher.Instance.isTest)
                    keymd5 = "5780125031940e9617e6eb2dd803367f";
                else
                    keymd5 = "9ecd0c8c8facfd438b72cbdd4dfe178a";

                //UnityEngine.Debug.Log("login acc: " + keymd5);
                string md5 = CLASSTAG_MD5Hashing.HashString(string.Format("account={0}+utime={1}+key={2}", arg0, arg1, keymd5));
                string result = string.Format("{0}-{1}-{2}", arg0, arg1, md5);
                LuaDLL.lua_pushstring(L, result);

                return 1;
            }
            else
            {
                return LuaDLL.luaL_throw(L, "invalid arguments to method: CLASSTAG_MD5Hashing.HashString");
            }
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_HashFile(IntPtr L)
    {
        try
        {
            ToLua.CheckArgsCount(L, 1);
            string arg0 = ToLua.CheckString(L, 1);
            string o = CLASSTAG_MD5Hashing.HashFile(arg0);
            LuaDLL.lua_pushstring(L, o);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_HashBytes(IntPtr L)
    {
        try
        {
            int count = LuaDLL.lua_gettop(L);

            if (count == 1 && TypeChecker.CheckTypes(L, 1, typeof(CLASSTAG_ByteArray)))
            {
                CLASSTAG_ByteArray arg0 = (CLASSTAG_ByteArray)ToLua.ToObject(L, 1);
                string o = CLASSTAG_MD5Hashing.HashBytes(arg0);
                LuaDLL.lua_pushstring(L, o);
                return 1;
            }
            else if (count == 1 && TypeChecker.CheckTypes(L, 1, typeof(byte[])))
            {
                byte[] arg0 = ToLua.CheckByteBuffer(L, 1);
                string o = CLASSTAG_MD5Hashing.HashBytes(arg0);
                LuaDLL.lua_pushstring(L, o);
                return 1;
            }
            else
            {
                return LuaDLL.luaL_throw(L, "invalid arguments to method: CLASSTAG_MD5Hashing.HashBytes");
            }
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }
}
